'''
Created on 09.01.2019

@author: LK
'''

class TMC4672_register:

    CHIPINFO_DATA                      = 0x00
    CHIPINFO_ADDR                      = 0x01
    ADC_RAW_DATA                       = 0x02
    ADC_RAW_ADDR                       = 0x03
    ADC_CONFIG_DATA                    = 0x04
    ADC_CONFIG_ADDR                    = 0x05
    ADC_IWY_IUX                        = 0x06
    ADC_IV_VM                          = 0x07
    AENC_WY_UX                         = 0x08
    AENC_VN                            = 0x09
    PWM_POLARITIES                     = 0x0A
    PWM_MAXCOUNT                       = 0x0B
    PWM_BBM_H_BBM_L                    = 0x0C
    PWM_SV_CHOP                        = 0x0D
    MOTOR_TYPE_N_POLE_PAIRS            = 0x0E
    ADC_I1_I0_EXT                      = 0x0F
    PHI_E_EXT                          = 0x11
    PHI_M_EXT                          = 0x12
    POSITION_EXT                       = 0x13
    OPENLOOP_MODE                      = 0x14
    OPENLOOP_ACCELERATION              = 0x15
    OPENLOOP_VELOCITY_TARGET           = 0x16
    OPENLOOP_VELOCITY_ACTUAL           = 0x17
    PHI_OPENLOOP                       = 0x18
    UQ_UD_EXT                          = 0x19
    POS_FB_CONFIG_DATA                 = 0x1A
    POS_FB_CONFIG_ADDR                 = 0x1B
    CONFIG_DATA                        = 0x1C
    CONFIG_ADDR                        = 0x1D
    ABN_DECODER_COUNT                  = 0x1E
    ABN_DECODER_COUNT_N                = 0x1F
    ABN_DECODER_PHI_E_PHI_M            = 0x20
    ABN_DECODER_POSITION               = 0x21
    ABN_2_DECODER_COUNT                = 0x22
    ABN_2_DECODER_COUNT_N              = 0x23
    ABN_2_DECODER_PHI_E_PHI_M          = 0x24
    ABN_2_DECODER_POSITION             = 0x25
    HALL_PHI_E_INTERPOLATED_PHI_E      = 0x26
    HALL_PHI_M                         = 0x27
    AENC_DECODER_COUNT                 = 0x28
    AENC_DECODER_COUNT_N               = 0x29
    AENC_DECODER_PHI_E_PHI_M           = 0x2A
    AENC_DECODER_POSITION              = 0x2B
    RAMP_STATUS                        = 0x2D
    RAMP_AMAX_A1                       = 0x2E
    RAMP_DMAX_D1                       = 0x2F
    RAMP_VSTART                        = 0x30
    RAMP_V1                            = 0x31
    RAMP_VSTOP                         = 0x32
    RAMP_TZEROWAIT_SWITCHMODE          = 0x33
    RAMP_X_ACTUAL                      = 0x34
    RAMP_V_ACTUAL                      = 0x35
    RAMP_X_TARGET                      = 0x36
    RAMP_V_FEEDFORWARD                 = 0x37
    OBSERVER_R_S_L_S_CROSS             = 0x3A
    OBSERVER_L_SD_L_SQ                 = 0x3B
    OBSERVER_K_EMF_INV_K_FILT          = 0x3C
    OBSERVER_K_D                       = 0x3D
    OBSERVER_E_SD                      = 0x3E
    OBSERVER_E_SQ                      = 0x3F
    OBSERVER_VELOCITY                  = 0x40
    OBSERVER_PHI_E                     = 0x41
    VELOCITY_SELECTION                 = 0x4A
    POSITION_SELECTION                 = 0x4B
    PHI_E_SELECTION                    = 0x4C
    PHI_E                              = 0x4D
    PID_FLUX_P_FLUX_I                  = 0x4E
    PID_TORQUE_P_TORQUE_I              = 0x50
    PID_VELOCITY_P_VELOCITY_I          = 0x54
    PID_POSITION_P_POSITION_I          = 0x57
    PID_TYPE                           = 0x58
    PIDOUT_UQ_UD_LIMITS                = 0x59
    PID_TORQUE_FLUX_LIMITS             = 0x5A
    PID_ACCELERATION_LIMIT             = 0x5B
    PID_VELOCITY_LIMIT                 = 0x5C
    PID_POSITION_LIMIT_LOW             = 0x5D
    PID_POSITION_LIMIT_HIGH            = 0x5E
    MODE_RAMP_MODE_MOTION              = 0x5F
    PID_TORQUE_FLUX_TARGET             = 0x60
    PID_TORQUE_FLUX_OFFSET             = 0x61
    PIDIN_TORQUE_FLUX_TARGET           = 0x62
    PID_VELOCITY_TARGET                = 0x63
    PID_VELOCITY_OFFSET                = 0x64
    PIDIN_VELOCITY_TARGET              = 0x65
    PID_POSITION_TARGET                = 0x66
    PID_TORQUE_FLUX_ACTUAL             = 0x67
    PID_VELOCITY_ACTUAL                = 0x68
    PID_POSITION_ACTUAL                = 0x69
    PID_ERROR_DATA                     = 0x6C
    PID_ERROR_ADDR                     = 0x6D
    INTERIM_DATA                       = 0x6E
    INTERIM_ADDR                       = 0x6F
    WATCHDOG_CFG                       = 0x70
    ADC_VM_LIMITS                      = 0x71
    INPUTS_RAW                         = 0x72
    OUTPUTS_RAW                        = 0x73
    STEP_WIDTH                         = 0x74
    UART_BPS                           = 0x75
    UART_ADDRS                         = 0x76
    GPIO_dsADCI_CONFIG                 = 0x77
    STATUS_FLAGS                       = 0x78
    STATUS_MASK                        = 0x79

    " motion modes "
    MOTION_MODE_STOPPED                = 0
    MOTION_MODE_TORQUE                 = 1
    MOTION_MODE_VELOCITY               = 2
    MOTION_MODE_POSITION               = 3
    MOTION_MODE_PRBS_FLUX              = 4
    MOTION_MODE_PRBS_TORQUE            = 5
    MOTION_MODE_PRBS_VELOCITY          = 6
    MOTION_MODE_PRBS_POSITION          = 7
    MOTION_MODE_UQ_UD_EXT              = 8
    MOTION_MODE_PIN_TORQUE_MODE        = 9
    MOTION_MODE_PIN_VELOCITY_MODE      = 10
    MOTION_MODE_PIN_POSITION_MODE      = 11
